Sign in Start for free

Deployment Targets

List all of the registered machines in the supplied Octopus Deploy Space, from all environments. The results will be sorted alphabetically by name

GET /api/{spaceId}/machines

Also reachable at /api/machines, /api/spaces/{spaceIdentifier}/machines.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • commStyles array of string
    List of communication styles which if specified, filters the result to only include Deployment Targets with matching communication styles.
  • deploymentTargetTypes array of string
    List of deployment target types which if specified, filters the result to only include Deployment Targets with matching types.
  • environmentIds array of string
    List of Environment IDs which if specified, filters the result to only include Deployment Targets with matching Environment IDs.
  • healthStatuses array of string
    List of health statuses which if specified, filters the result to only include Deployment Targets with matching health statuses.
  • ids array of string
    List of Deployment Target IDs which if specified, filters the result to only include Deployment Targets with matching IDs.
  • isDisabled boolean
    A filter to return only disabled/enabled Deployment Targets.
  • name string
    The exact name of a deployment target to be matched.
  • operatingSystemNames array of string
    List of operating system names which if specified, filters the result to only include Deployment Targets with matching operating systems.
  • partialName string
    A partial or complete name to search on. This will perform a “contains” style match against the supplied name or name-fragment.
  • roles array of string
    List of roles which if specified, filters the result to only include Deployment Targets with matching roles.
  • shellNames array of string
    List of shell names which if specified, filters the result to only include Deployment Targets with matching shells.
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.
  • targetTags array of string
    List of Target Tags which if specified, filters the result to only include Deployment Targets with matching Target Tags.
  • tenantIds array of string
    List of Tenant IDs which if specified, filters the result to only include Deployment Targets with matching Tenant IDs.
  • tenantTags array of string
    List of Tenant Tags which if specified, filters the result to only include Deployment Targets with matching Tenant Tags.

Response

200 — The list of alphabetically sorted deployment targets that matched the request.

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • Architecture string
    • Endpoint object
    • EnvironmentIds array of string
    • HasLatestCalamari boolean
    • HealthStatus enum
      Allowed values: Healthy, Unavailable, Unknown, HasWarnings, Unhealthy.
    • Id string
      Gets or sets a unique identifier for this resource.
    • IsDisabled boolean
    • IsInProcess boolean
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • MachinePolicyId string
    • Name string
    • OperatingSystem string
    • OperatingSystemVersion string
    • Roles array of string
    • ShellName string
    • ShellVersion string
    • SkipInitialHealthCheck boolean
    • Slug string
    • SpaceId string
    • StatusSummary string
    • TenantIds array of string
    • TenantTags array of string
    • TenantedDeploymentParticipation enum
      Allowed values: Untenanted, TenantedOrUntenanted, Tenanted.
    • Thumbprint string
    • Uri string
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "Architecture": "string",
      "Endpoint": {
        "CommunicationStyle": "None",
        "Id": "string",
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "Links": {}
      },
      "EnvironmentIds": [
        "string"
      ],
      "HasLatestCalamari": true,
      "HealthStatus": "Healthy",
      "Id": "string",
      "IsDisabled": true,
      "IsInProcess": true,
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "MachinePolicyId": "string",
      "Name": "string",
      "OperatingSystem": "string",
      "OperatingSystemVersion": "string",
      "Roles": [
        "string"
      ],
      "ShellName": "string",
      "ShellVersion": "string",
      "SkipInitialHealthCheck": true,
      "Slug": "string",
      "SpaceId": "string",
      "StatusSummary": "string",
      "TenantIds": [
        "string"
      ],
      "TenantTags": [
        "string"
      ],
      "TenantedDeploymentParticipation": "Untenanted",
      "Thumbprint": "string",
      "Uri": "string"
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

Create a MachineResource

POST /api/{spaceId}/machines

Also reachable at /api/machines, /api/spaces/{spaceIdentifier}/machines.

Creates a new deployment target.

Path Parameters

  • spaceId string (required)

Request Body

  • Endpoint object
    • CommunicationStyle enum
      This is for legacy support in client. Server no longer uses this for determining endpoint types, it uses DeploymentTargetType.
      Allowed values: None, TentaclePassive, TentacleActive, Ssh, OfflineDrop, AzureWebApp, Ftp, AzureCloudService, AzureServiceFabricCluster, Kubernetes, StepPackage, KubernetesTentacle, AwsEcsCluster.
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • EnvironmentIds array of string (required)
  • IsDisabled boolean
  • MachinePolicyId string
  • Name string (required)
    Minimum length 1.
  • Roles array of string (required)
  • SkipInitialHealthCheck boolean
  • Slug string
  • SpaceId string (required)
  • TenantIds array of string
  • TenantTags array of string
  • TenantedDeploymentParticipation enum
    Allowed values: Untenanted, TenantedOrUntenanted, Tenanted.
  • Thumbprint string
  • Uri string

Response

201 — Created

  • Architecture string
  • Endpoint object
    • CommunicationStyle enum
      This is for legacy support in client. Server no longer uses this for determining endpoint types, it uses DeploymentTargetType.
      Allowed values: None, TentaclePassive, TentacleActive, Ssh, OfflineDrop, AzureWebApp, Ftp, AzureCloudService, AzureServiceFabricCluster, Kubernetes, StepPackage, KubernetesTentacle, AwsEcsCluster.
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • EnvironmentIds array of string
  • HasLatestCalamari boolean
  • HealthStatus enum
    Allowed values: Healthy, Unavailable, Unknown, HasWarnings, Unhealthy.
  • Id string
    Gets or sets a unique identifier for this resource.
  • IsDisabled boolean
  • IsInProcess boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • MachinePolicyId string
  • Name string
  • OperatingSystem string
  • OperatingSystemVersion string
  • Roles array of string
  • ShellName string
  • ShellVersion string
  • SkipInitialHealthCheck boolean
  • Slug string
  • SpaceId string
  • StatusSummary string
  • TenantIds array of string
  • TenantTags array of string
  • TenantedDeploymentParticipation enum
    Allowed values: Untenanted, TenantedOrUntenanted, Tenanted.
  • Thumbprint string
  • Uri string

Example Request

JSON
{
  "Endpoint": {
    "CommunicationStyle": "None",
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    }
  },
  "EnvironmentIds": [
    "string"
  ],
  "IsDisabled": true,
  "MachinePolicyId": "string",
  "Name": "string",
  "Roles": [
    "string"
  ],
  "SkipInitialHealthCheck": true,
  "Slug": "string",
  "SpaceId": "string",
  "TenantIds": [
    "string"
  ],
  "TenantTags": [
    "string"
  ],
  "TenantedDeploymentParticipation": "Untenanted",
  "Thumbprint": "string",
  "Uri": "string"
}

Example Response

JSON
{
  "Architecture": "string",
  "Endpoint": {
    "CommunicationStyle": "None",
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    }
  },
  "EnvironmentIds": [
    "string"
  ],
  "HasLatestCalamari": true,
  "HealthStatus": "Healthy",
  "Id": "string",
  "IsDisabled": true,
  "IsInProcess": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "MachinePolicyId": "string",
  "Name": "string",
  "OperatingSystem": "string",
  "OperatingSystemVersion": "string",
  "Roles": [
    "string"
  ],
  "ShellName": "string",
  "ShellVersion": "string",
  "SkipInitialHealthCheck": true,
  "Slug": "string",
  "SpaceId": "string",
  "StatusSummary": "string",
  "TenantIds": [
    "string"
  ],
  "TenantTags": [
    "string"
  ],
  "TenantedDeploymentParticipation": "Untenanted",
  "Thumbprint": "string",
  "Uri": "string"
}

Get a list of Deployment Targets

GET /api/{spaceId}/machines/all

Also reachable at /api/machines/all, /api/spaces/{spaceIdentifier}/machines/all.

Lists all of the Deployment Targets in the supplied Space. The results will be sorted alphabetically by name.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • ids array of string
    A comma separated list of Machine resource ids used to filter a query.
  • thumbprint string
    A thumbprint used to filter a query.

Response

200 — Requested list of Deployment Targets

  • Architecture string
  • Endpoint object
    • CommunicationStyle enum
      This is for legacy support in client. Server no longer uses this for determining endpoint types, it uses DeploymentTargetType.
      Allowed values: None, TentaclePassive, TentacleActive, Ssh, OfflineDrop, AzureWebApp, Ftp, AzureCloudService, AzureServiceFabricCluster, Kubernetes, StepPackage, KubernetesTentacle, AwsEcsCluster.
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • EnvironmentIds array of string
  • HasLatestCalamari boolean
  • HealthStatus enum
    Allowed values: Healthy, Unavailable, Unknown, HasWarnings, Unhealthy.
  • Id string
    Gets or sets a unique identifier for this resource.
  • IsDisabled boolean
  • IsInProcess boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • MachinePolicyId string
  • Name string
  • OperatingSystem string
  • OperatingSystemVersion string
  • Roles array of string
  • ShellName string
  • ShellVersion string
  • SkipInitialHealthCheck boolean
  • Slug string
  • SpaceId string
  • StatusSummary string
  • TenantIds array of string
  • TenantTags array of string
  • TenantedDeploymentParticipation enum
    Allowed values: Untenanted, TenantedOrUntenanted, Tenanted.
  • Thumbprint string
  • Uri string

Example Response

JSON
[
  {
    "Architecture": "string",
    "Endpoint": {
      "CommunicationStyle": "None",
      "Id": "string",
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      }
    },
    "EnvironmentIds": [
      "string"
    ],
    "HasLatestCalamari": true,
    "HealthStatus": "Healthy",
    "Id": "string",
    "IsDisabled": true,
    "IsInProcess": true,
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "MachinePolicyId": "string",
    "Name": "string",
    "OperatingSystem": "string",
    "OperatingSystemVersion": "string",
    "Roles": [
      "string"
    ],
    "ShellName": "string",
    "ShellVersion": "string",
    "SkipInitialHealthCheck": true,
    "Slug": "string",
    "SpaceId": "string",
    "StatusSummary": "string",
    "TenantIds": [
      "string"
    ],
    "TenantTags": [
      "string"
    ],
    "TenantedDeploymentParticipation": "Untenanted",
    "Thumbprint": "string",
    "Uri": "string"
  }
]

Get a list of Deployment Targets

GET /api/{spaceId}/machines/all/v1

Also reachable at /api/machines/all/v1, /api/spaces/{spaceIdentifier}/machines/all/v1.

Lists all of the Deployment Targets in the supplied Space. The results will be sorted alphabetically by name.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • ids array of string
    A comma separated list of Machine resource ids used to filter a query.
  • thumbprint string
    A thumbprint used to filter a query.

Response

200 — Requested list of Deployment Targets

  • DeploymentTargets array of object
    • Architecture string
    • Endpoint object
    • EnvironmentIds array of string
    • HasLatestCalamari boolean
    • HealthStatus enum
      Allowed values: Healthy, Unavailable, Unknown, HasWarnings, Unhealthy.
    • Id string
      Gets or sets a unique identifier for this resource.
    • IsDisabled boolean
    • IsInProcess boolean
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • MachinePolicyId string
    • Name string
    • OperatingSystem string
    • OperatingSystemVersion string
    • Roles array of string
    • ShellName string
    • ShellVersion string
    • SkipInitialHealthCheck boolean
    • Slug string
    • SpaceId string
    • StatusSummary string
    • TenantIds array of string
    • TenantTags array of string
    • TenantedDeploymentParticipation enum
      Allowed values: Untenanted, TenantedOrUntenanted, Tenanted.
    • Thumbprint string
    • Uri string

Example Response

JSON
{
  "DeploymentTargets": [
    {
      "Architecture": "string",
      "Endpoint": {
        "CommunicationStyle": "None",
        "Id": "string",
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "Links": {}
      },
      "EnvironmentIds": [
        "string"
      ],
      "HasLatestCalamari": true,
      "HealthStatus": "Healthy",
      "Id": "string",
      "IsDisabled": true,
      "IsInProcess": true,
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "MachinePolicyId": "string",
      "Name": "string",
      "OperatingSystem": "string",
      "OperatingSystemVersion": "string",
      "Roles": [
        "string"
      ],
      "ShellName": "string",
      "ShellVersion": "string",
      "SkipInitialHealthCheck": true,
      "Slug": "string",
      "SpaceId": "string",
      "StatusSummary": "string",
      "TenantIds": [
        "string"
      ],
      "TenantTags": [
        "string"
      ],
      "TenantedDeploymentParticipation": "Untenanted",
      "Thumbprint": "string",
      "Uri": "string"
    }
  ]
}

Interrogate a deployment target for communication details so that it may be added to the installation

GET /api/{spaceId}/machines/discover

Also reachable at /api/machines/discover, /api/spaces/{spaceIdentifier}/machines/discover.

Path Parameters

  • spaceId string (required)

Query Parameters

  • host string (required)
  • port integer
  • proxyId string
  • type enum
    Allowed values: TentaclePassive, TentacleActive, Ssh.

Response

200 — The machine which was discovered

  • Architecture string
  • Endpoint object
    • CommunicationStyle enum
      This is for legacy support in client. Server no longer uses this for determining endpoint types, it uses DeploymentTargetType.
      Allowed values: None, TentaclePassive, TentacleActive, Ssh, OfflineDrop, AzureWebApp, Ftp, AzureCloudService, AzureServiceFabricCluster, Kubernetes, StepPackage, KubernetesTentacle, AwsEcsCluster.
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • HasLatestCalamari boolean
  • HealthStatus enum
    Allowed values: Healthy, Unavailable, Unknown, HasWarnings, Unhealthy.
  • Id string
    Gets or sets a unique identifier for this resource.
  • IsDisabled boolean
  • IsInProcess boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • MachinePolicyId string
  • Name string
  • OperatingSystem string
  • OperatingSystemVersion string
  • ShellName string
  • ShellVersion string
  • SkipInitialHealthCheck boolean
  • Slug string
  • StatusSummary string
  • Thumbprint string
  • Uri string

Example Response

JSON
{
  "Architecture": "string",
  "Endpoint": {
    "CommunicationStyle": "None",
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    }
  },
  "HasLatestCalamari": true,
  "HealthStatus": "Healthy",
  "Id": "string",
  "IsDisabled": true,
  "IsInProcess": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "MachinePolicyId": "string",
  "Name": "string",
  "OperatingSystem": "string",
  "OperatingSystemVersion": "string",
  "ShellName": "string",
  "ShellVersion": "string",
  "SkipInitialHealthCheck": true,
  "Slug": "string",
  "StatusSummary": "string",
  "Thumbprint": "string",
  "Uri": "string"
}

Get all operating system names for deployment targets

GET /api/{spaceId}/machines/operatingsystem/names/all

Also reachable at /api/machines/operatingsystem/names/all, /api/spaces/{spaceIdentifier}/machines/operatingsystem/names/all.

Path Parameters

  • spaceId string (required)

Response

200 — The operating system names

Example Response

JSON
[
  "string"
]

Get all operating system shell names for deployment targets

GET /api/{spaceId}/machines/operatingsystem/shells/all

Also reachable at /api/machines/operatingsystem/shells/all, /api/spaces/{spaceIdentifier}/machines/operatingsystem/shells/all.

Path Parameters

  • spaceId string (required)

Response

200 — The operating system shell names

Example Response

JSON
[
  "string"
]

List all of the registered machines in the supplied Octopus Deploy Space, from all environments. The results are sorted by health status, healthiest first, then alphabetically by name

GET /api/{spaceId}/machines/v2

Also reachable at /api/machines/v2, /api/spaces/{spaceIdentifier}/machines/v2.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • commStyles array of string
    List of communication styles which if specified, filters the result to only include Deployment Targets with matching communication styles.
  • deploymentTargetTypes array of string
    List of deployment target types which if specified, filters the result to only include Deployment Targets with matching types.
  • environmentIds array of string
    List of Environment IDs which if specified, filters the result to only include Deployment Targets with matching Environment IDs.
  • healthStatuses array of string
    List of health statuses which if specified, filters the result to only include Deployment Targets with matching health statuses.
  • ids array of string
    List of Deployment Target IDs which if specified, filters the result to only include Deployment Targets with matching IDs.
  • isDisabled boolean
    A filter to return only disabled/enabled Deployment Targets.
  • name string
    The exact name of a deployment target to be matched.
  • operatingSystemNames array of string
    List of operating system names which if specified, filters the result to only include Deployment Targets with matching operating systems.
  • partialName string
    A partial or complete name to search on. This will perform a “contains” style match against the supplied name or name-fragment.
  • roles array of string
    List of roles which if specified, filters the result to only include Deployment Targets with matching roles.
  • shellNames array of string
    List of shell names which if specified, filters the result to only include Deployment Targets with matching shells.
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.
  • targetTags array of string
    List of Target Tags which if specified, filters the result to only include Deployment Targets with matching Target Tags.
  • tenantIds array of string
    List of Tenant IDs which if specified, filters the result to only include Deployment Targets with matching Tenant IDs.
  • tenantTags array of string
    List of Tenant Tags which if specified, filters the result to only include Deployment Targets with matching Tenant Tags.

Response

200 — The list of alphabetically sorted deployment targets that matched the request.

  • DeploymentTargets object
    • ItemType string
    • Items array of object
    • ItemsPerPage integer
    • LastPageNumber integer
    • NumberOfPages integer
    • TotalResults integer
  • TargetCountPerHealthStatus object

Example Response

JSON
{
  "DeploymentTargets": {
    "ItemType": "string",
    "Items": [
      {
        "Architecture": "string",
        "Endpoint": {},
        "EnvironmentIds": [
          "string"
        ],
        "HasLatestCalamari": true,
        "HealthStatus": "Healthy",
        "Id": "string",
        "IsDisabled": true,
        "IsInProcess": true,
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "Links": {},
        "MachinePolicyId": "string",
        "Name": "string",
        "OperatingSystem": "string",
        "OperatingSystemVersion": "string",
        "Roles": [
          "string"
        ],
        "ShellName": "string",
        "ShellVersion": "string",
        "SkipInitialHealthCheck": true,
        "Slug": "string",
        "SpaceId": "string",
        "StatusSummary": "string",
        "TenantIds": [
          "string"
        ],
        "TenantTags": [
          "string"
        ],
        "TenantedDeploymentParticipation": "Untenanted",
        "Thumbprint": "string",
        "Uri": "string"
      }
    ],
    "ItemsPerPage": 0,
    "LastPageNumber": 0,
    "NumberOfPages": 0,
    "TotalResults": 0
  },
  "TargetCountPerHealthStatus": {
    "additionalProp1": 0,
    "additionalProp2": 0,
    "additionalProp3": 0
  }
}

Get an existing Deployment Target

GET /api/{spaceId}/machines/{id}

Also reachable at /api/machines/{id}, /api/spaces/{spaceIdentifier}/machines/{id}.

Path Parameters

  • id string (required)
    The id of the Machine.
  • spaceId string (required)
    The id of the space that contains the Machine.

Response

200 — The Deployment Target resource to return.

  • Architecture string
  • Endpoint object
    • CommunicationStyle enum
      This is for legacy support in client. Server no longer uses this for determining endpoint types, it uses DeploymentTargetType.
      Allowed values: None, TentaclePassive, TentacleActive, Ssh, OfflineDrop, AzureWebApp, Ftp, AzureCloudService, AzureServiceFabricCluster, Kubernetes, StepPackage, KubernetesTentacle, AwsEcsCluster.
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • EnvironmentIds array of string
  • HasLatestCalamari boolean
  • HealthStatus enum
    Allowed values: Healthy, Unavailable, Unknown, HasWarnings, Unhealthy.
  • Id string
    Gets or sets a unique identifier for this resource.
  • IsDisabled boolean
  • IsInProcess boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • MachinePolicyId string
  • Name string
  • OperatingSystem string
  • OperatingSystemVersion string
  • Roles array of string
  • ShellName string
  • ShellVersion string
  • SkipInitialHealthCheck boolean
  • Slug string
  • SpaceId string
  • StatusSummary string
  • TenantIds array of string
  • TenantTags array of string
  • TenantedDeploymentParticipation enum
    Allowed values: Untenanted, TenantedOrUntenanted, Tenanted.
  • Thumbprint string
  • Uri string

Example Response

JSON
{
  "Architecture": "string",
  "Endpoint": {
    "CommunicationStyle": "None",
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    }
  },
  "EnvironmentIds": [
    "string"
  ],
  "HasLatestCalamari": true,
  "HealthStatus": "Healthy",
  "Id": "string",
  "IsDisabled": true,
  "IsInProcess": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "MachinePolicyId": "string",
  "Name": "string",
  "OperatingSystem": "string",
  "OperatingSystemVersion": "string",
  "Roles": [
    "string"
  ],
  "ShellName": "string",
  "ShellVersion": "string",
  "SkipInitialHealthCheck": true,
  "Slug": "string",
  "SpaceId": "string",
  "StatusSummary": "string",
  "TenantIds": [
    "string"
  ],
  "TenantTags": [
    "string"
  ],
  "TenantedDeploymentParticipation": "Untenanted",
  "Thumbprint": "string",
  "Uri": "string"
}

Delete an existing Deployment Target

DELETE /api/{spaceId}/machines/{id}

Also reachable at /api/machines/{id}, /api/spaces/{spaceIdentifier}/machines/{id}.

Path Parameters

  • id string (required)
    ID of the Deployment Target to delete.
  • spaceId string (required)
    The SpaceId of the deployment target to delete.

Response

200 — Success

Get a list of the latest deployments by project for the given Deployment Target

GET /api/{spaceId}/machines/{id}/latestdeployments

Also reachable at /api/machines/{id}/latestdeployments, /api/spaces/{spaceIdentifier}/machines/{id}/latestdeployments.

Path Parameters

  • id string (required)
    ID of the Deployment Target.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • partialName string
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.

Response

200 — The requested list of latest deployments per project for the Deployment Target

  • ItemType string
  • Items array of object
    • ProjectId string
    • ProjectLogo string
      Minimum length 1.
    • ProjectName string
      Minimum length 1.
    • ServerTask object
  • ItemsPerPage integer
  • LastPageNumber integer
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "ItemType": "string",
  "Items": [
    {
      "ProjectId": "string",
      "ProjectLogo": "string",
      "ProjectName": "string",
      "ServerTask": {
        "Arguments": {},
        "CanRerun": true,
        "Completed": "string",
        "CompletedTime": "2020-01-01T00:00:00.000Z",
        "Description": "string",
        "Duration": "string",
        "ErrorMessage": "string",
        "EstimatedRemainingQueueDurationSeconds": 0,
        "FinishedSuccessfully": true,
        "HasBeenPickedUpByProcessor": true,
        "HasPendingInterruptions": true,
        "HasPendingPreconditions": true,
        "HasWarningsOrErrors": true,
        "Id": "string",
        "IsCompleted": true,
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "LastUpdatedTime": "2020-01-01T00:00:00.000Z",
        "Links": {},
        "Name": "string",
        "PendingInterruptionTypes": [
          "ManualIntervention"
        ],
        "PendingPreconditionTypes": [
          "string"
        ],
        "ProjectId": "string",
        "QueueTime": "2020-01-01T00:00:00.000Z",
        "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
        "ServerNode": "string",
        "SpaceId": "string",
        "StartTime": "2020-01-01T00:00:00.000Z",
        "State": "Queued"
      }
    }
  ],
  "ItemsPerPage": 0,
  "LastPageNumber": 0,
  "NumberOfPages": 0,
  "TotalResults": 0
}

Get a list of Tasks for the given Deployment Target

GET /api/{spaceId}/machines/{id}/tasks

Also reachable at /api/machines/{id}/tasks, /api/spaces/{spaceIdentifier}/machines/{id}/tasks.

Get a history of related Tasks (ie. Deployments) for a Deployment Target.

Path Parameters

  • id string (required)
    ID of the Deployment Target.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.
  • type enum
    The type of Task to retrieve. If left blank, all Tasks are retrieved.
    Allowed values: Deployment, RunbookRun.

Response

200 — The requested list of Tasks for the Deployment Target

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • Arguments object
      Gets or sets any arguments to the task.
    • CanRerun boolean
      If true, then the task can be used as the basis for a new task with the same effect.
    • Completed string
      Gets or sets a value indicating the completion status of the task. May be “Timed out”, “Queued…”, “Executing…”, or the time at which the task completed for completed tasks.
    • CompletedTime string
      Gets or sets the date/time that the task completed. Will be null if the task has not yet completed. Format date-time.
    • Description string
      Gets or sets a short, human-understandable description of this task. An example might be “Manual database backup”. This is the name that will be shown in the task list.
    • Duration string
      Gets or sets a string indicating how long the task took to run.
    • ErrorMessage string
      Gets or sets a short summary of the errors encountered when the task ran (if any).
    • EstimatedRemainingQueueDurationSeconds integer
    • FinishedSuccessfully boolean
      Gets or sets a value indicating whether the task ran to completion successfully.
    • HasBeenPickedUpByProcessor boolean
      Gets or sets a boolean value indicating whether the Octopus Server is processing this task.
    • HasPendingInterruptions boolean
      True if the task has any pending interruptions.
    • HasPendingPreconditions boolean
      True if the task has any pending preconditions.
    • HasWarningsOrErrors boolean
      True if any warnings or non-fatal errors were recorded in the task log during execution.
    • Id string
      Gets or sets a unique identifier for this resource.
    • IsCompleted boolean
      Gets or sets a value indicating whether the task has completed (that is, not queued, not running, and not paused; may have finished successfully or failed).
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • LastUpdatedTime string
      Gets or sets the time that the Octopus server last updated the status of this task. For a running task this should happen at least every couple of minutes. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • Name string
      Gets or sets the name of the task to create. This name must be one of the list of possible names documented in the create API operation documentation.
    • PendingInterruptionTypes array of enum
      Contains a list of the types of any pending interruptions.
      Allowed values: ManualIntervention, GuidedFailure, PullRequestCompletion, ArgoCDApplicationSync, KubernetesResourceVerification.
    • PendingPreconditionTypes array of string
      Contains a list of the types of any pending preconditions.
    • ProjectId string
      If the task belongs to a project (e.g. a deployment), the ID of the project it belongs to.
    • QueueTime string
      Gets or sets the time at which the task was queued. Format date-time.
    • QueueTimeExpiry string
      Gets or sets the time at which the task will timeout if it has not started executing. Format date-time.
    • ServerNode string
      Gets the ID of the Octopus server that created and will control this task.
    • SpaceId string
    • StartTime string
      Gets or sets the time at which the task started executing. Format date-time.
    • State enum
      Gets or sets the current state of the task.
      Allowed values: Queued, Executing, Failed, Canceled, TimedOut, Success, Cancelling.
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "Arguments": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "CanRerun": true,
      "Completed": "string",
      "CompletedTime": "2020-01-01T00:00:00.000Z",
      "Description": "string",
      "Duration": "string",
      "ErrorMessage": "string",
      "EstimatedRemainingQueueDurationSeconds": 0,
      "FinishedSuccessfully": true,
      "HasBeenPickedUpByProcessor": true,
      "HasPendingInterruptions": true,
      "HasPendingPreconditions": true,
      "HasWarningsOrErrors": true,
      "Id": "string",
      "IsCompleted": true,
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "LastUpdatedTime": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Name": "string",
      "PendingInterruptionTypes": [
        "ManualIntervention"
      ],
      "PendingPreconditionTypes": [
        "string"
      ],
      "ProjectId": "string",
      "QueueTime": "2020-01-01T00:00:00.000Z",
      "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
      "ServerNode": "string",
      "SpaceId": "string",
      "StartTime": "2020-01-01T00:00:00.000Z",
      "State": "Queued"
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

Get a list of Tasks for the given Deployment Target

GET /api/{spaceId}/machines/{id}/tasks/v1

Also reachable at /api/machines/{id}/tasks/v1, /api/spaces/{spaceIdentifier}/machines/{id}/tasks/v1.

Get a history of related Tasks (ie. Deployments) for a Deployment Target.

Path Parameters

  • id string (required)
    ID of the Deployment Target.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.
  • type enum
    The type of Task to retrieve. If left blank, all Tasks are retrieved.
    Allowed values: Deployment, RunbookRun.

Response

200 — The requested list of Tasks for the Deployment Target

  • ResourceCollection object
    • Id string
      Gets or sets a unique identifier for this resource.
    • ItemType string
    • Items array of object
    • ItemsPerPage integer
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • LastPageNumber integer
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • NumberOfPages integer
    • TotalResults integer

Example Response

JSON
{
  "ResourceCollection": {
    "Id": "string",
    "ItemType": "string",
    "Items": [
      {
        "Arguments": {},
        "CanRerun": true,
        "Completed": "string",
        "CompletedTime": "2020-01-01T00:00:00.000Z",
        "Description": "string",
        "Duration": "string",
        "ErrorMessage": "string",
        "EstimatedRemainingQueueDurationSeconds": 0,
        "FinishedSuccessfully": true,
        "HasBeenPickedUpByProcessor": true,
        "HasPendingInterruptions": true,
        "HasPendingPreconditions": true,
        "HasWarningsOrErrors": true,
        "Id": "string",
        "IsCompleted": true,
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "LastUpdatedTime": "2020-01-01T00:00:00.000Z",
        "Links": {},
        "Name": "string",
        "PendingInterruptionTypes": [
          "ManualIntervention"
        ],
        "PendingPreconditionTypes": [
          "string"
        ],
        "ProjectId": "string",
        "QueueTime": "2020-01-01T00:00:00.000Z",
        "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
        "ServerNode": "string",
        "SpaceId": "string",
        "StartTime": "2020-01-01T00:00:00.000Z",
        "State": "Queued"
      }
    ],
    "ItemsPerPage": 0,
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "LastPageNumber": 0,
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "NumberOfPages": 0,
    "TotalResults": 0
  }
}

List all the variable set names (projects and library variable sets) that have variables that are scoped to only the given machine

GET /api/{spaceId}/machines/{machineId}/singlyScopedVariableDetails

Also reachable at /api/machines/{machineId}/singlyScopedVariableDetails, /api/spaces/{spaceIdentifier}/machines/{machineId}/singlyScopedVariableDetails.

Path Parameters

  • machineId string (required)
  • spaceId string (required)

Response

200 — The names of LibraryVariableSets and VariableSets which contain one or more variables scoped to the requested machine. Along with boolean indication to show that there are unviewable/editable projects/libraries which also contain scoped variables.

  • Resource object
    • HasUnauthorizedLibraryVariableSetVariables boolean
    • HasUnauthorizedProjectVariables boolean
    • VariableMap object

Example Response

JSON
{
  "Resource": {
    "HasUnauthorizedLibraryVariableSetVariables": true,
    "HasUnauthorizedProjectVariables": true,
    "VariableMap": {
      "additionalProp1": {
        "additionalProp1": 0,
        "additionalProp2": 0,
        "additionalProp3": 0
      },
      "additionalProp2": {
        "additionalProp1": 0,
        "additionalProp2": 0,
        "additionalProp3": 0
      },
      "additionalProp3": {
        "additionalProp1": 0,
        "additionalProp2": 0,
        "additionalProp3": 0
      }
    }
  }
}

Modify an existing Deployment Target (identified by ID)

PUT /api/{spaceId}/machines/{machineid}

Also reachable at /api/machines/{machineid}, /api/spaces/{spaceIdentifier}/machines/{machineid}.

Path Parameters

  • machineid string (required)
  • spaceId string (required)

Request Body

  • Endpoint object
    • CommunicationStyle enum
      This is for legacy support in client. Server no longer uses this for determining endpoint types, it uses DeploymentTargetType.
      Allowed values: None, TentaclePassive, TentacleActive, Ssh, OfflineDrop, AzureWebApp, Ftp, AzureCloudService, AzureServiceFabricCluster, Kubernetes, StepPackage, KubernetesTentacle, AwsEcsCluster.
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • EnvironmentIds array of string (required)
  • IsDisabled boolean
  • MachineId string (required)
  • MachinePolicyId string
    Note: If this is unset, but the endpoint requires a policy, Octopus will update the machine with the default machine policy.
  • Name string (required)
    Minimum length 1.
  • Roles array of string (required)
  • Slug string
  • SpaceId string (required)
  • TenantIds array of string
  • TenantTags array of string
  • TenantedDeploymentParticipation enum
    Allowed values: Untenanted, TenantedOrUntenanted, Tenanted.
  • Thumbprint string
  • Uri string

Response

200 — The MachineResource following requested changes.

  • Architecture string
  • Endpoint object
    • CommunicationStyle enum
      This is for legacy support in client. Server no longer uses this for determining endpoint types, it uses DeploymentTargetType.
      Allowed values: None, TentaclePassive, TentacleActive, Ssh, OfflineDrop, AzureWebApp, Ftp, AzureCloudService, AzureServiceFabricCluster, Kubernetes, StepPackage, KubernetesTentacle, AwsEcsCluster.
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • EnvironmentIds array of string
  • HasLatestCalamari boolean
  • HealthStatus enum
    Allowed values: Healthy, Unavailable, Unknown, HasWarnings, Unhealthy.
  • Id string
    Gets or sets a unique identifier for this resource.
  • IsDisabled boolean
  • IsInProcess boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • MachinePolicyId string
  • Name string
  • OperatingSystem string
  • OperatingSystemVersion string
  • Roles array of string
  • ShellName string
  • ShellVersion string
  • SkipInitialHealthCheck boolean
  • Slug string
  • SpaceId string
  • StatusSummary string
  • TenantIds array of string
  • TenantTags array of string
  • TenantedDeploymentParticipation enum
    Allowed values: Untenanted, TenantedOrUntenanted, Tenanted.
  • Thumbprint string
  • Uri string

Example Request

JSON
{
  "Endpoint": {
    "CommunicationStyle": "None",
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    }
  },
  "EnvironmentIds": [
    "string"
  ],
  "IsDisabled": true,
  "MachineId": "string",
  "MachinePolicyId": "string",
  "Name": "string",
  "Roles": [
    "string"
  ],
  "Slug": "string",
  "SpaceId": "string",
  "TenantIds": [
    "string"
  ],
  "TenantTags": [
    "string"
  ],
  "TenantedDeploymentParticipation": "Untenanted",
  "Thumbprint": "string",
  "Uri": "string"
}

Example Response

JSON
{
  "Architecture": "string",
  "Endpoint": {
    "CommunicationStyle": "None",
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    }
  },
  "EnvironmentIds": [
    "string"
  ],
  "HasLatestCalamari": true,
  "HealthStatus": "Healthy",
  "Id": "string",
  "IsDisabled": true,
  "IsInProcess": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "MachinePolicyId": "string",
  "Name": "string",
  "OperatingSystem": "string",
  "OperatingSystemVersion": "string",
  "Roles": [
    "string"
  ],
  "ShellName": "string",
  "ShellVersion": "string",
  "SkipInitialHealthCheck": true,
  "Slug": "string",
  "SpaceId": "string",
  "StatusSummary": "string",
  "TenantIds": [
    "string"
  ],
  "TenantTags": [
    "string"
  ],
  "TenantedDeploymentParticipation": "Untenanted",
  "Thumbprint": "string",
  "Uri": "string"
}